## Understanding the Data Feluda Uses

Feluda is a configurable engine that lets people plug-in different operators or libraries such as Google Cloud Vision API, ResNet, pHash. One can also add their own custom analysis tool as an operator to Feluda. Feluda, by itself, does not collect any data. The data that a model uses depends on the operators applied in a specific application. One can rely on a model like ResNet to cluster similar images. This is a model that captures visual and semantic information about the images. But you could also cluster similar images using a non ML technique like pHash which only captures visual similarity. This is a trade off that you could make to keep your operating cost low or to avoid using a model whose data practices you don't agree with. Feluda frees you up to make those choices and quickly iterate on an approach that gives you desired results while adhering to your constraints.

To understand which operators are being used in an application enabled by Feluda, please check [config-indexer](https://github.com/tattle-made/feluda/blob/master/src/config-indexer.yml). You can see the libraries the specific operator relies on, please check the [operator's configuration file](https://github.com/tattle-made/feluda/tree/master/src/core/operators). The data collected in the application, and its adherance with various privacy legislation depends on the specific operators enabled in an application. We request you to review the specific operator's data collection practices and compliance with your local laws to see if you should use it in Feluda in your application.
